//------------------------------------------------------------------------------
// Defines zur besseren Lesbarkeit
//------------------------------------------------------------------------------
#define PURE        0
#define ANZELEMENTE 5
#define NULL        0L

//------------------------------------------------------------------------------
// Basisklasse GRAPHELEMENT, stellt alle Methoden virtuell zur Verfgung
//------------------------------------------------------------------------------
class GraphElement
{
	public:
      virtual ~GraphElement (void) {};
		virtual void Draw (void) = PURE;
};

//------------------------------------------------------------------------------
// abgeleitete Klasse KREIS, MUSS die Methoden oben vorsehen, da diese PURE sind
//------------------------------------------------------------------------------
class Kreis : public GraphElement
{
	public:
      virtual ~Kreis (void) {};
		virtual void Draw (void) {};
};

//------------------------------------------------------------------------------
// Testprogramm
//------------------------------------------------------------------------------
void main (void)
{
	GraphElement *Zeichnung [ANZELEMENTE];
   int i;

   //---------------------------------------------------------------------------
   // Vorbelegung
   //---------------------------------------------------------------------------
   for (i=0; i<ANZELEMENTE; i++)
   {
   	Zeichnung[i] = NULL;
   }

   //---------------------------------------------------------------------------
   // Objekte erzeugen
   //---------------------------------------------------------------------------
   for (i=0; i<ANZELEMENTE; i++)
   {
   	Zeichnung[i] = new Kreis;
   }

   //---------------------------------------------------------------------------
   // Daten wieder lschen
   //---------------------------------------------------------------------------
   for (i=0; i<ANZELEMENTE; i++)
   {
   	delete Zeichnung[i];
      Zeichnung[i] = NULL;
   }
}
