#include <iostream.h>

//------------------------------------------------------------------------------
// Defines zur besseren Lesbarkeit
//------------------------------------------------------------------------------
#define PURE        0
#define ANZELEMENTE 5

//------------------------------------------------------------------------------
// Basisklasse GRAPHELEMENT, stellt alle Methoden virtuell zur Verfgung
//------------------------------------------------------------------------------
class GraphElement
{
	public:
      virtual ~GraphElement (void) {};
		virtual void Draw (void) = PURE;
};

//------------------------------------------------------------------------------
// abgeleitete Klasse KREIS, MUSS die Methoden oben vorsehen, da diese PURE sind
//------------------------------------------------------------------------------
class Kreis : public GraphElement
{
	public:
      virtual ~Kreis (void) {};
		virtual void Draw (void) {};
};

//------------------------------------------------------------------------------
// abgeleitete Klasse QUADRAT,MUSS die Methoden oben vorsehen,da diese PURE sind
//------------------------------------------------------------------------------
class Quadrat : public GraphElement
{
	public:
      virtual ~Quadrat (void) {};
		virtual void Draw (void) {};
};

//------------------------------------------------------------------------------
// Testprogramm
//------------------------------------------------------------------------------
void main (void)
{
	GraphElement *Zeichnung [ANZELEMENTE];
   char Eingabe [80] = "";
   int i;

   //---------------------------------------------------------------------------
   // Vorbelegung
   //---------------------------------------------------------------------------
   for (i=0; i<ANZELEMENTE; i++)
   {
   	Zeichnung[i] = NULL;
   }

   //---------------------------------------------------------------------------
   // Eingaben
   //---------------------------------------------------------------------------
   cout << "Bitte 'Q' fr Quadrat oder 'K' fr Kreis eingeben: " << endl;

   i=0;
   while (i<ANZELEMENTE)
   {
   	cout << (i+1) << ".tes Element :";

      cin.getline(Eingabe, 80);
      switch (Eingabe[0])
      {
      	case  'Q' :
      	case  'q' : Zeichnung [i] = new Quadrat;
                     i++;
                     break;
      	case  'K' :
      	case  'k' : Zeichnung [i] = new Kreis;
                     i++;
                     break;
      }
   }

   //***************************************************************************
   //*** auf welchen Datentyp zeigt an dieser Zeichnung[3] ???????
   //***************************************************************************

   //---------------------------------------------------------------------------
   // Daten wieder lschen
   //---------------------------------------------------------------------------
   for (i=0; i<ANZELEMENTE; i++)
   {
   	delete Zeichnung[i];
      Zeichnung[i] = NULL;
   }
}
