#include <excpt.h>
#include <except.h>
#include <iostream.h>
#include <stdlib.h>

//------------------------------------------------------------------------------
// Fakultts-Fehler-Objekt
//------------------------------------------------------------------------------
class FakulError
{
   protected:
      int error;

   public:
      FakulError (int i = 0) {error = i;}
      void GetError (void);
};

//------------------------------------------------------------------------------
// Fakultts-Fehlermethode
//------------------------------------------------------------------------------
void FakulError::GetError (void)
{
	cout << "Fakultt: ";
	switch (error)
   {
   	case 1 : cout << "negativer Wert";
               break;
   	case 2 : cout << "Parameter zu gro";
               break;
      default: cout << "unbekannter Fehler";
               break;
   }
}

//------------------------------------------------------------------------------
// Funktion mit Exceptionhandling
//------------------------------------------------------------------------------
double fnFakultaet (int Param)
{
   double Ergebnis = 1.0;

   //---------------------------------------------------------------------------
   // Exception auslsen
   //---------------------------------------------------------------------------
   if (Param > 50) throw FakulError(2);
   if (Param < 0)  throw FakulError(1);

  	if (0 == Param) Param = 1;
   for (int i=Param; i>1; i--) Ergebnis *= i;

   return Ergebnis;
}

//------------------------------------------------------------------------------
// Testprogramm
//------------------------------------------------------------------------------
void main (void)
{
   char sEingabe [80];
   int fak = 0;

   cout << "Parameter : ";
   cin.getline (sEingabe, 80);
   fak = atoi (sEingabe);

   //---------------------------------------------------------------------------
   // Die folgenden Codezeilen berwachen (try-Block)
   //---------------------------------------------------------------------------
   try
   {
      cout << fnFakultaet (fak) << endl;
   }
   //---------------------------------------------------------------------------
   // Exceptionhandler, wird aufgerufen, wenn im try-Block eine Exception
   // ausgelst wird
   //---------------------------------------------------------------------------
   catch (FakulError& x)
   {
      x.GetError();
   }
   
   cout << endl << "Programmende" << endl;
}

