#include <iostream.h>
#include <stdlib.h>
#include <assert.h>

#define ARRAYSIZE 5

class Alpha
{
	public:
   	void Test (void) { cout << "Alpha" << endl; }
};

//------------------------------------------------------------------------------
// Testprogramm
//------------------------------------------------------------------------------
void main (void)
{
	char sEingabe [80];
   int i;
   int nIndex;
   int nArray [ARRAYSIZE];
   Alpha *pAlpha = NULL;

   for (i=0; i<ARRAYSIZE; i++)
   {
   	nArray [i] = i+1;
   }

   cout << "Bitte angeben, welches Arrayelement gelesen wreden soll: ";
   cin.getline (sEingabe, 80);
   nIndex = atoi (sEingabe);

	//---------------------------------------------------------------------------
	// Zusicherungen. Die Asserts kann man auch zusammenfassen zu:
   // assert ((nIndex < ARRAYSIZE) && (nIndex >= 0)), dann wei man aber im
   // Falle eines Fehlers nicht, welche der beiden Bedingungen verletzt wurde
	//---------------------------------------------------------------------------
   assert (nIndex < ARRAYSIZE);
   assert (nIndex >= 0);

   cout << "Arrayelement : " << nArray [nIndex] << endl;

	//---------------------------------------------------------------------------
	// typische Zusicherung: der Pointer darf noch einen Wert haben
	//---------------------------------------------------------------------------
	assert (NULL == pAlpha);

   cout << "Geben Sie 'T' fr eine korrekte Objektallokation ein - oder einen "
           "anderen Buchstaben um einen ASSERT auszulsen :";
   cin.getline (sEingabe, 80);
   switch (sEingabe[0])
   {
      case 'T' :
      case 't' : pAlpha = new Alpha;
   }

	//---------------------------------------------------------------------------
	// typische Zusicherung: der Pointer mu einen Wert haben
	//---------------------------------------------------------------------------
	assert (pAlpha);

   pAlpha->Test();
   delete pAlpha;
   pAlpha = NULL;
}

